import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_PutOriginEndpointPolicyCommand, se_PutOriginEndpointPolicyCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class PutOriginEndpointPolicyCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("mediapackagev2", "PutOriginEndpointPolicy", {})
    .n("MediaPackageV2Client", "PutOriginEndpointPolicyCommand")
    .f(void 0, void 0)
    .ser(se_PutOriginEndpointPolicyCommand)
    .de(de_PutOriginEndpointPolicyCommand)
    .build() {
}
