import { loadRestJsonErrorCode, parseJsonBody as parseBody, parseJsonErrorBody as parseErrorBody } from "@aws-sdk/core";
import { requestBuilder as rb } from "@smithy/core";
import { _json, collectBody, decorateServiceException as __decorateServiceException, expectInt32 as __expectInt32, expectNonNull as __expectNonNull, expectNumber as __expectNumber, expectObject as __expectObject, expectString as __expectString, map, parseEpochTimestamp as __parseEpochTimestamp, take, withBaseException, } from "@smithy/smithy-client";
import { MediaPackageV2ServiceException as __BaseException } from "../models/MediaPackageV2ServiceException";
import { AccessDeniedException, ConflictException, InternalServerException, ResourceNotFoundException, ServiceQuotaExceededException, ThrottlingException, ValidationException, } from "../models/models_0";
export const se_CreateChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xact]: input[_CT],
    });
    b.bp("/channelGroup/{ChannelGroupName}/channel");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    let body;
    body = JSON.stringify(take(input, {
        ChannelName: [],
        Description: [],
        tags: [, (_) => _json(_), `Tags`],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_CreateChannelGroupCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xact]: input[_CT],
    });
    b.bp("/channelGroup");
    let body;
    body = JSON.stringify(take(input, {
        ChannelGroupName: [],
        Description: [],
        tags: [, (_) => _json(_), `Tags`],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_CreateOriginEndpointCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xact]: input[_CT],
    });
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    body = JSON.stringify(take(input, {
        ContainerType: [],
        Description: [],
        HlsManifests: (_) => se_CreateHlsManifests(_, context),
        LowLatencyHlsManifests: (_) => se_CreateLowLatencyHlsManifests(_, context),
        OriginEndpointName: [],
        Segment: (_) => _json(_),
        StartoverWindowSeconds: [],
        Tags: (_) => _json(_),
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_DeleteChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeleteChannelGroupCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeleteChannelPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeleteOriginEndpointCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_DeleteOriginEndpointPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    b.m("DELETE").h(headers).b(body);
    return b.build();
};
export const se_GetChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetChannelGroupCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetChannelPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetOriginEndpointCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_GetOriginEndpointPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_ListChannelGroupsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup");
    const query = map({
        [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
        [_nT]: [, input[_NT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListChannelsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    const query = map({
        [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
        [_nT]: [, input[_NT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListOriginEndpointsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    const query = map({
        [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
        [_nT]: [, input[_NT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListTagsForResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_PutChannelPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    body = JSON.stringify(take(input, {
        Policy: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_PutOriginEndpointPolicyCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    body = JSON.stringify(take(input, {
        Policy: [],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_TagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    body = JSON.stringify(take(input, {
        tags: [, (_) => _json(_), `Tags`],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_UntagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    const query = map({
        [_tK]: [
            __expectNonNull(input.TagKeys, `TagKeys`) != null,
            () => (input[_TK] || []).map((_entry) => _entry),
        ],
    });
    let body;
    b.m("DELETE").h(headers).q(query).b(body);
    return b.build();
};
export const se_UpdateChannelCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xauim]: input[_ET],
    });
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    let body;
    body = JSON.stringify(take(input, {
        Description: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_UpdateChannelGroupCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xauim]: input[_ET],
    });
    b.bp("/channelGroup/{ChannelGroupName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    let body;
    body = JSON.stringify(take(input, {
        Description: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_UpdateOriginEndpointCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = map({}, isSerializableHeaderValue, {
        "content-type": "application/json",
        [_xauim]: input[_ET],
    });
    b.bp("/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}");
    b.p("ChannelGroupName", () => input.ChannelGroupName, "{ChannelGroupName}", false);
    b.p("ChannelName", () => input.ChannelName, "{ChannelName}", false);
    b.p("OriginEndpointName", () => input.OriginEndpointName, "{OriginEndpointName}", false);
    let body;
    body = JSON.stringify(take(input, {
        ContainerType: [],
        Description: [],
        HlsManifests: (_) => se_CreateHlsManifests(_, context),
        LowLatencyHlsManifests: (_) => se_CreateLowLatencyHlsManifests(_, context),
        Segment: (_) => _json(_),
        StartoverWindowSeconds: [],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const de_CreateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        IngestEndpoints: _json,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_CreateChannelGroupCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        EgressDomain: __expectString,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_CreateOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        ContainerType: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        HlsManifests: (_) => de_GetHlsManifests(_, context),
        LowLatencyHlsManifests: (_) => de_GetLowLatencyHlsManifests(_, context),
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        OriginEndpointName: __expectString,
        Segment: _json,
        StartoverWindowSeconds: __expectInt32,
        Tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_DeleteChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeleteChannelGroupCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeleteChannelPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeleteOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_DeleteOriginEndpointPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_GetChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        IngestEndpoints: _json,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetChannelGroupCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        EgressDomain: __expectString,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetChannelPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        Policy: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        ContainerType: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        HlsManifests: (_) => de_GetHlsManifests(_, context),
        LowLatencyHlsManifests: (_) => de_GetLowLatencyHlsManifests(_, context),
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        OriginEndpointName: __expectString,
        Segment: _json,
        StartoverWindowSeconds: __expectInt32,
        Tags: _json,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetOriginEndpointPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        OriginEndpointName: __expectString,
        Policy: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListChannelGroupsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Items: (_) => de_ChannelGroupsList(_, context),
        NextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListChannelsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Items: (_) => de_ChannelList(_, context),
        NextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListOriginEndpointsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Items: (_) => de_OriginEndpointsList(_, context),
        NextToken: __expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_PutChannelPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_PutOriginEndpointPolicyCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UpdateChannelCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        IngestEndpoints: _json,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_UpdateChannelGroupCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        EgressDomain: __expectString,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_UpdateOriginEndpointCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        ContainerType: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ETag: __expectString,
        HlsManifests: (_) => de_GetHlsManifests(_, context),
        LowLatencyHlsManifests: (_) => de_GetLowLatencyHlsManifests(_, context),
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        OriginEndpointName: __expectString,
        Segment: _json,
        StartoverWindowSeconds: __expectInt32,
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
const de_CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.mediapackagev2#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.mediapackagev2#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.mediapackagev2#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.mediapackagev2#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.mediapackagev2#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.mediapackagev2#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.mediapackagev2#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const throwDefaultError = withBaseException(__BaseException);
const de_AccessDeniedExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ConflictExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        ConflictExceptionType: __expectString,
        Message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_InternalServerExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
        ResourceTypeNotFound: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ServiceQuotaExceededExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ThrottlingExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ValidationExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Message: __expectString,
        ValidationExceptionType: __expectString,
    });
    Object.assign(contents, doc);
    const exception = new ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const se_CreateHlsManifestConfiguration = (input, context) => {
    return take(input, {
        ChildManifestName: [],
        FilterConfiguration: (_) => se_FilterConfiguration(_, context),
        ManifestName: [],
        ManifestWindowSeconds: [],
        ProgramDateTimeIntervalSeconds: [],
        ScteHls: _json,
    });
};
const se_CreateHlsManifests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CreateHlsManifestConfiguration(entry, context);
    });
};
const se_CreateLowLatencyHlsManifestConfiguration = (input, context) => {
    return take(input, {
        ChildManifestName: [],
        FilterConfiguration: (_) => se_FilterConfiguration(_, context),
        ManifestName: [],
        ManifestWindowSeconds: [],
        ProgramDateTimeIntervalSeconds: [],
        ScteHls: _json,
    });
};
const se_CreateLowLatencyHlsManifests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_CreateLowLatencyHlsManifestConfiguration(entry, context);
    });
};
const se_FilterConfiguration = (input, context) => {
    return take(input, {
        End: (_) => Math.round(_.getTime() / 1000),
        ManifestFilter: [],
        Start: (_) => Math.round(_.getTime() / 1000),
        TimeDelaySeconds: [],
    });
};
const de_ChannelGroupListConfiguration = (output, context) => {
    return take(output, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
    });
};
const de_ChannelGroupsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ChannelGroupListConfiguration(entry, context);
    });
    return retVal;
};
const de_ChannelList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ChannelListConfiguration(entry, context);
    });
    return retVal;
};
const de_ChannelListConfiguration = (output, context) => {
    return take(output, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
    });
};
const de_FilterConfiguration = (output, context) => {
    return take(output, {
        End: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        ManifestFilter: __expectString,
        Start: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        TimeDelaySeconds: __expectInt32,
    });
};
const de_GetHlsManifestConfiguration = (output, context) => {
    return take(output, {
        ChildManifestName: __expectString,
        FilterConfiguration: (_) => de_FilterConfiguration(_, context),
        ManifestName: __expectString,
        ManifestWindowSeconds: __expectInt32,
        ProgramDateTimeIntervalSeconds: __expectInt32,
        ScteHls: _json,
        Url: __expectString,
    });
};
const de_GetHlsManifests = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_GetHlsManifestConfiguration(entry, context);
    });
    return retVal;
};
const de_GetLowLatencyHlsManifestConfiguration = (output, context) => {
    return take(output, {
        ChildManifestName: __expectString,
        FilterConfiguration: (_) => de_FilterConfiguration(_, context),
        ManifestName: __expectString,
        ManifestWindowSeconds: __expectInt32,
        ProgramDateTimeIntervalSeconds: __expectInt32,
        ScteHls: _json,
        Url: __expectString,
    });
};
const de_GetLowLatencyHlsManifests = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_GetLowLatencyHlsManifestConfiguration(entry, context);
    });
    return retVal;
};
const de_OriginEndpointListConfiguration = (output, context) => {
    return take(output, {
        Arn: __expectString,
        ChannelGroupName: __expectString,
        ChannelName: __expectString,
        ContainerType: __expectString,
        CreatedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        Description: __expectString,
        HlsManifests: _json,
        LowLatencyHlsManifests: _json,
        ModifiedAt: (_) => __expectNonNull(__parseEpochTimestamp(__expectNumber(_))),
        OriginEndpointName: __expectString,
    });
};
const de_OriginEndpointsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_OriginEndpointListConfiguration(entry, context);
    });
    return retVal;
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const _CT = "ClientToken";
const _ET = "ETag";
const _MR = "MaxResults";
const _NT = "NextToken";
const _TK = "TagKeys";
const _mR = "maxResults";
const _nT = "nextToken";
const _tK = "tagKeys";
const _xact = "x-amzn-client-token";
const _xauim = "x-amzn-update-if-match";
