import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { MediaPackageV2ClientResolvedConfig } from "../MediaPackageV2Client";
export interface MediaPackageV2HttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface MediaPackageV2HttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    MediaPackageV2ClientResolvedConfig,
    HandlerExecutionContext,
    MediaPackageV2HttpAuthSchemeParameters,
    object
  > {}
export declare const defaultMediaPackageV2HttpAuthSchemeParametersProvider: (
  config: MediaPackageV2ClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<MediaPackageV2HttpAuthSchemeParameters>;
export interface MediaPackageV2HttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<MediaPackageV2HttpAuthSchemeParameters> {}
export declare const defaultMediaPackageV2HttpAuthSchemeProvider: MediaPackageV2HttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: MediaPackageV2HttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: MediaPackageV2HttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
