import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { MediaPackageV2ServiceException as __BaseException } from "./MediaPackageV2ServiceException";
export declare class AccessDeniedException extends __BaseException {
  readonly name: "AccessDeniedException";
  readonly $fault: "client";
  Message?: string;
  constructor(
    opts: __ExceptionOptionType<AccessDeniedException, __BaseException>
  );
}
export declare const AdMarkerHls: {
  readonly DATERANGE: "DATERANGE";
};
export type AdMarkerHls = (typeof AdMarkerHls)[keyof typeof AdMarkerHls];
export interface ChannelGroupListConfiguration {
  ChannelGroupName: string | undefined;
  Arn: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
}
export declare const ConflictExceptionType: {
  readonly CONFLICTING_OPERATION: "CONFLICTING_OPERATION";
  readonly IDEMPOTENT_PARAMETER_MISMATCH: "IDEMPOTENT_PARAMETER_MISMATCH";
  readonly RESOURCE_ALREADY_EXISTS: "RESOURCE_ALREADY_EXISTS";
  readonly RESOURCE_IN_USE: "RESOURCE_IN_USE";
};
export type ConflictExceptionType =
  (typeof ConflictExceptionType)[keyof typeof ConflictExceptionType];
export declare class ConflictException extends __BaseException {
  readonly name: "ConflictException";
  readonly $fault: "client";
  Message?: string;
  ConflictExceptionType?: ConflictExceptionType;
  constructor(opts: __ExceptionOptionType<ConflictException, __BaseException>);
}
export interface DeleteChannelPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
}
export interface DeleteChannelPolicyResponse {}
export declare class InternalServerException extends __BaseException {
  readonly name: "InternalServerException";
  readonly $fault: "server";
  Message?: string;
  constructor(
    opts: __ExceptionOptionType<InternalServerException, __BaseException>
  );
}
export declare class ThrottlingException extends __BaseException {
  readonly name: "ThrottlingException";
  readonly $fault: "client";
  Message?: string;
  constructor(
    opts: __ExceptionOptionType<ThrottlingException, __BaseException>
  );
}
export declare const ValidationExceptionType: {
  readonly CENC_IV_INCOMPATIBLE: "CENC_IV_INCOMPATIBLE";
  readonly CONTAINER_TYPE_IMMUTABLE: "CONTAINER_TYPE_IMMUTABLE";
  readonly DRM_SYSTEMS_ENCRYPTION_METHOD_INCOMPATIBLE: "DRM_SYSTEMS_ENCRYPTION_METHOD_INCOMPATIBLE";
  readonly ENCRYPTION_CONTRACT_SHARED: "ENCRYPTION_CONTRACT_SHARED";
  readonly ENCRYPTION_CONTRACT_UNENCRYPTED: "ENCRYPTION_CONTRACT_UNENCRYPTED";
  readonly ENCRYPTION_CONTRACT_WITHOUT_AUDIO_RENDITION_INCOMPATIBLE: "ENCRYPTION_CONTRACT_WITHOUT_AUDIO_RENDITION_INCOMPATIBLE";
  readonly ENCRYPTION_METHOD_CONTAINER_TYPE_MISMATCH: "ENCRYPTION_METHOD_CONTAINER_TYPE_MISMATCH";
  readonly END_TIME_EARLIER_THAN_START_TIME: "END_TIME_EARLIER_THAN_START_TIME";
  readonly INVALID_MANIFEST_FILTER: "INVALID_MANIFEST_FILTER";
  readonly INVALID_PAGINATION_MAX_RESULTS: "INVALID_PAGINATION_MAX_RESULTS";
  readonly INVALID_PAGINATION_TOKEN: "INVALID_PAGINATION_TOKEN";
  readonly INVALID_POLICY: "INVALID_POLICY";
  readonly INVALID_ROLE_ARN: "INVALID_ROLE_ARN";
  readonly INVALID_TIME_DELAY_SECONDS: "INVALID_TIME_DELAY_SECONDS";
  readonly MANIFEST_NAME_COLLISION: "MANIFEST_NAME_COLLISION";
  readonly MEMBER_DOES_NOT_MATCH_PATTERN: "MEMBER_DOES_NOT_MATCH_PATTERN";
  readonly MEMBER_INVALID: "MEMBER_INVALID";
  readonly MEMBER_INVALID_ENUM_VALUE: "MEMBER_INVALID_ENUM_VALUE";
  readonly MEMBER_MAX_LENGTH: "MEMBER_MAX_LENGTH";
  readonly MEMBER_MAX_VALUE: "MEMBER_MAX_VALUE";
  readonly MEMBER_MIN_LENGTH: "MEMBER_MIN_LENGTH";
  readonly MEMBER_MIN_VALUE: "MEMBER_MIN_VALUE";
  readonly MEMBER_MISSING: "MEMBER_MISSING";
  readonly NUM_MANIFESTS_HIGH: "NUM_MANIFESTS_HIGH";
  readonly NUM_MANIFESTS_LOW: "NUM_MANIFESTS_LOW";
  readonly ROLE_ARN_INVALID_FORMAT: "ROLE_ARN_INVALID_FORMAT";
  readonly ROLE_ARN_LENGTH_OUT_OF_RANGE: "ROLE_ARN_LENGTH_OUT_OF_RANGE";
  readonly ROLE_ARN_NOT_ASSUMABLE: "ROLE_ARN_NOT_ASSUMABLE";
  readonly URL_INVALID: "URL_INVALID";
  readonly URL_LINK_LOCAL_ADDRESS: "URL_LINK_LOCAL_ADDRESS";
  readonly URL_LOCAL_ADDRESS: "URL_LOCAL_ADDRESS";
  readonly URL_LOOPBACK_ADDRESS: "URL_LOOPBACK_ADDRESS";
  readonly URL_MULTICAST_ADDRESS: "URL_MULTICAST_ADDRESS";
  readonly URL_PORT: "URL_PORT";
  readonly URL_SCHEME: "URL_SCHEME";
  readonly URL_UNKNOWN_HOST: "URL_UNKNOWN_HOST";
  readonly URL_USER_INFO: "URL_USER_INFO";
};
export type ValidationExceptionType =
  (typeof ValidationExceptionType)[keyof typeof ValidationExceptionType];
export declare class ValidationException extends __BaseException {
  readonly name: "ValidationException";
  readonly $fault: "client";
  Message?: string;
  ValidationExceptionType?: ValidationExceptionType;
  constructor(
    opts: __ExceptionOptionType<ValidationException, __BaseException>
  );
}
export interface GetChannelPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
}
export interface GetChannelPolicyResponse {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  Policy: string | undefined;
}
export declare const ResourceTypeNotFound: {
  readonly CHANNEL: "CHANNEL";
  readonly CHANNEL_GROUP: "CHANNEL_GROUP";
  readonly ORIGIN_ENDPOINT: "ORIGIN_ENDPOINT";
};
export type ResourceTypeNotFound =
  (typeof ResourceTypeNotFound)[keyof typeof ResourceTypeNotFound];
export declare class ResourceNotFoundException extends __BaseException {
  readonly name: "ResourceNotFoundException";
  readonly $fault: "client";
  Message?: string;
  ResourceTypeNotFound?: ResourceTypeNotFound;
  constructor(
    opts: __ExceptionOptionType<ResourceNotFoundException, __BaseException>
  );
}
export interface PutChannelPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  Policy: string | undefined;
}
export interface PutChannelPolicyResponse {}
export interface CreateChannelRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  ClientToken?: string;
  Description?: string;
  Tags?: Record<string, string>;
}
export interface IngestEndpoint {
  Id?: string;
  Url?: string;
}
export interface CreateChannelResponse {
  Arn: string | undefined;
  ChannelName: string | undefined;
  ChannelGroupName: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  IngestEndpoints?: IngestEndpoint[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export declare class ServiceQuotaExceededException extends __BaseException {
  readonly name: "ServiceQuotaExceededException";
  readonly $fault: "client";
  Message?: string;
  constructor(
    opts: __ExceptionOptionType<ServiceQuotaExceededException, __BaseException>
  );
}
export interface DeleteChannelRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
}
export interface DeleteChannelResponse {}
export interface GetChannelRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
}
export interface GetChannelResponse {
  Arn: string | undefined;
  ChannelName: string | undefined;
  ChannelGroupName: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  IngestEndpoints?: IngestEndpoint[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface ListChannelsRequest {
  ChannelGroupName: string | undefined;
  MaxResults?: number;
  NextToken?: string;
}
export interface ChannelListConfiguration {
  Arn: string | undefined;
  ChannelName: string | undefined;
  ChannelGroupName: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
}
export interface ListChannelsResponse {
  Items?: ChannelListConfiguration[];
  NextToken?: string;
}
export declare const ContainerType: {
  readonly CMAF: "CMAF";
  readonly TS: "TS";
};
export type ContainerType = (typeof ContainerType)[keyof typeof ContainerType];
export interface FilterConfiguration {
  ManifestFilter?: string;
  Start?: Date;
  End?: Date;
  TimeDelaySeconds?: number;
}
export interface ScteHls {
  AdMarkerHls?: AdMarkerHls;
}
export interface CreateHlsManifestConfiguration {
  ManifestName: string | undefined;
  ChildManifestName?: string;
  ScteHls?: ScteHls;
  ManifestWindowSeconds?: number;
  ProgramDateTimeIntervalSeconds?: number;
  FilterConfiguration?: FilterConfiguration;
}
export interface CreateLowLatencyHlsManifestConfiguration {
  ManifestName: string | undefined;
  ChildManifestName?: string;
  ScteHls?: ScteHls;
  ManifestWindowSeconds?: number;
  ProgramDateTimeIntervalSeconds?: number;
  FilterConfiguration?: FilterConfiguration;
}
export declare const CmafEncryptionMethod: {
  readonly CBCS: "CBCS";
  readonly CENC: "CENC";
};
export type CmafEncryptionMethod =
  (typeof CmafEncryptionMethod)[keyof typeof CmafEncryptionMethod];
export declare const TsEncryptionMethod: {
  readonly AES_128: "AES_128";
  readonly SAMPLE_AES: "SAMPLE_AES";
};
export type TsEncryptionMethod =
  (typeof TsEncryptionMethod)[keyof typeof TsEncryptionMethod];
export interface EncryptionMethod {
  TsEncryptionMethod?: TsEncryptionMethod;
  CmafEncryptionMethod?: CmafEncryptionMethod;
}
export declare const DrmSystem: {
  readonly CLEAR_KEY_AES_128: "CLEAR_KEY_AES_128";
  readonly FAIRPLAY: "FAIRPLAY";
  readonly PLAYREADY: "PLAYREADY";
  readonly WIDEVINE: "WIDEVINE";
};
export type DrmSystem = (typeof DrmSystem)[keyof typeof DrmSystem];
export declare const PresetSpeke20Audio: {
  readonly PRESET_AUDIO_1: "PRESET_AUDIO_1";
  readonly PRESET_AUDIO_2: "PRESET_AUDIO_2";
  readonly PRESET_AUDIO_3: "PRESET_AUDIO_3";
  readonly SHARED: "SHARED";
  readonly UNENCRYPTED: "UNENCRYPTED";
};
export type PresetSpeke20Audio =
  (typeof PresetSpeke20Audio)[keyof typeof PresetSpeke20Audio];
export declare const PresetSpeke20Video: {
  readonly PRESET_VIDEO_1: "PRESET_VIDEO_1";
  readonly PRESET_VIDEO_2: "PRESET_VIDEO_2";
  readonly PRESET_VIDEO_3: "PRESET_VIDEO_3";
  readonly PRESET_VIDEO_4: "PRESET_VIDEO_4";
  readonly PRESET_VIDEO_5: "PRESET_VIDEO_5";
  readonly PRESET_VIDEO_6: "PRESET_VIDEO_6";
  readonly PRESET_VIDEO_7: "PRESET_VIDEO_7";
  readonly PRESET_VIDEO_8: "PRESET_VIDEO_8";
  readonly SHARED: "SHARED";
  readonly UNENCRYPTED: "UNENCRYPTED";
};
export type PresetSpeke20Video =
  (typeof PresetSpeke20Video)[keyof typeof PresetSpeke20Video];
export interface EncryptionContractConfiguration {
  PresetSpeke20Audio: PresetSpeke20Audio | undefined;
  PresetSpeke20Video: PresetSpeke20Video | undefined;
}
export interface SpekeKeyProvider {
  EncryptionContractConfiguration: EncryptionContractConfiguration | undefined;
  ResourceId: string | undefined;
  DrmSystems: DrmSystem[] | undefined;
  RoleArn: string | undefined;
  Url: string | undefined;
}
export interface Encryption {
  ConstantInitializationVector?: string;
  EncryptionMethod: EncryptionMethod | undefined;
  KeyRotationIntervalSeconds?: number;
  SpekeKeyProvider: SpekeKeyProvider | undefined;
}
export declare const ScteFilter: {
  readonly BREAK: "BREAK";
  readonly DISTRIBUTOR_ADVERTISEMENT: "DISTRIBUTOR_ADVERTISEMENT";
  readonly DISTRIBUTOR_OVERLAY_PLACEMENT_OPPORTUNITY: "DISTRIBUTOR_OVERLAY_PLACEMENT_OPPORTUNITY";
  readonly DISTRIBUTOR_PLACEMENT_OPPORTUNITY: "DISTRIBUTOR_PLACEMENT_OPPORTUNITY";
  readonly PROGRAM: "PROGRAM";
  readonly PROVIDER_ADVERTISEMENT: "PROVIDER_ADVERTISEMENT";
  readonly PROVIDER_OVERLAY_PLACEMENT_OPPORTUNITY: "PROVIDER_OVERLAY_PLACEMENT_OPPORTUNITY";
  readonly PROVIDER_PLACEMENT_OPPORTUNITY: "PROVIDER_PLACEMENT_OPPORTUNITY";
  readonly SPLICE_INSERT: "SPLICE_INSERT";
};
export type ScteFilter = (typeof ScteFilter)[keyof typeof ScteFilter];
export interface Scte {
  ScteFilter?: ScteFilter[];
}
export interface Segment {
  SegmentDurationSeconds?: number;
  SegmentName?: string;
  TsUseAudioRenditionGroup?: boolean;
  IncludeIframeOnlyStreams?: boolean;
  TsIncludeDvbSubtitles?: boolean;
  Scte?: Scte;
  Encryption?: Encryption;
}
export interface CreateOriginEndpointRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Segment?: Segment;
  ClientToken?: string;
  Description?: string;
  StartoverWindowSeconds?: number;
  HlsManifests?: CreateHlsManifestConfiguration[];
  LowLatencyHlsManifests?: CreateLowLatencyHlsManifestConfiguration[];
  Tags?: Record<string, string>;
}
export interface GetHlsManifestConfiguration {
  ManifestName: string | undefined;
  Url: string | undefined;
  ChildManifestName?: string;
  ManifestWindowSeconds?: number;
  ProgramDateTimeIntervalSeconds?: number;
  ScteHls?: ScteHls;
  FilterConfiguration?: FilterConfiguration;
}
export interface GetLowLatencyHlsManifestConfiguration {
  ManifestName: string | undefined;
  Url: string | undefined;
  ChildManifestName?: string;
  ManifestWindowSeconds?: number;
  ProgramDateTimeIntervalSeconds?: number;
  ScteHls?: ScteHls;
  FilterConfiguration?: FilterConfiguration;
}
export interface CreateOriginEndpointResponse {
  Arn: string | undefined;
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Segment: Segment | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  StartoverWindowSeconds?: number;
  HlsManifests?: GetHlsManifestConfiguration[];
  LowLatencyHlsManifests?: GetLowLatencyHlsManifestConfiguration[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface DeleteOriginEndpointRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
}
export interface DeleteOriginEndpointResponse {}
export interface GetOriginEndpointRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
}
export interface GetOriginEndpointResponse {
  Arn: string | undefined;
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Segment: Segment | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  StartoverWindowSeconds?: number;
  HlsManifests?: GetHlsManifestConfiguration[];
  LowLatencyHlsManifests?: GetLowLatencyHlsManifestConfiguration[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface ListOriginEndpointsRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  MaxResults?: number;
  NextToken?: string;
}
export interface ListHlsManifestConfiguration {
  ManifestName: string | undefined;
  ChildManifestName?: string;
  Url?: string;
}
export interface ListLowLatencyHlsManifestConfiguration {
  ManifestName: string | undefined;
  ChildManifestName?: string;
  Url?: string;
}
export interface OriginEndpointListConfiguration {
  Arn: string | undefined;
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Description?: string;
  CreatedAt?: Date;
  ModifiedAt?: Date;
  HlsManifests?: ListHlsManifestConfiguration[];
  LowLatencyHlsManifests?: ListLowLatencyHlsManifestConfiguration[];
}
export interface ListOriginEndpointsResponse {
  Items?: OriginEndpointListConfiguration[];
  NextToken?: string;
}
export interface DeleteOriginEndpointPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
}
export interface DeleteOriginEndpointPolicyResponse {}
export interface GetOriginEndpointPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
}
export interface GetOriginEndpointPolicyResponse {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  Policy: string | undefined;
}
export interface PutOriginEndpointPolicyRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  Policy: string | undefined;
}
export interface PutOriginEndpointPolicyResponse {}
export interface UpdateOriginEndpointRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Segment?: Segment;
  Description?: string;
  StartoverWindowSeconds?: number;
  HlsManifests?: CreateHlsManifestConfiguration[];
  LowLatencyHlsManifests?: CreateLowLatencyHlsManifestConfiguration[];
  ETag?: string;
}
export interface UpdateOriginEndpointResponse {
  Arn: string | undefined;
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  OriginEndpointName: string | undefined;
  ContainerType: ContainerType | undefined;
  Segment: Segment | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  StartoverWindowSeconds?: number;
  HlsManifests?: GetHlsManifestConfiguration[];
  LowLatencyHlsManifests?: GetLowLatencyHlsManifestConfiguration[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface UpdateChannelRequest {
  ChannelGroupName: string | undefined;
  ChannelName: string | undefined;
  ETag?: string;
  Description?: string;
}
export interface UpdateChannelResponse {
  Arn: string | undefined;
  ChannelName: string | undefined;
  ChannelGroupName: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  IngestEndpoints?: IngestEndpoint[];
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface CreateChannelGroupRequest {
  ChannelGroupName: string | undefined;
  ClientToken?: string;
  Description?: string;
  Tags?: Record<string, string>;
}
export interface CreateChannelGroupResponse {
  ChannelGroupName: string | undefined;
  Arn: string | undefined;
  EgressDomain: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  ETag?: string;
  Description?: string;
  Tags?: Record<string, string>;
}
export interface DeleteChannelGroupRequest {
  ChannelGroupName: string | undefined;
}
export interface DeleteChannelGroupResponse {}
export interface GetChannelGroupRequest {
  ChannelGroupName: string | undefined;
}
export interface GetChannelGroupResponse {
  ChannelGroupName: string | undefined;
  Arn: string | undefined;
  EgressDomain: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface ListChannelGroupsRequest {
  MaxResults?: number;
  NextToken?: string;
}
export interface ListChannelGroupsResponse {
  Items?: ChannelGroupListConfiguration[];
  NextToken?: string;
}
export interface UpdateChannelGroupRequest {
  ChannelGroupName: string | undefined;
  ETag?: string;
  Description?: string;
}
export interface UpdateChannelGroupResponse {
  ChannelGroupName: string | undefined;
  Arn: string | undefined;
  EgressDomain: string | undefined;
  CreatedAt: Date | undefined;
  ModifiedAt: Date | undefined;
  Description?: string;
  ETag?: string;
  Tags?: Record<string, string>;
}
export interface ListTagsForResourceRequest {
  ResourceArn: string | undefined;
}
export interface ListTagsForResourceResponse {
  Tags?: Record<string, string>;
}
export interface TagResourceRequest {
  ResourceArn: string | undefined;
  Tags: Record<string, string> | undefined;
}
export interface UntagResourceRequest {
  ResourceArn: string | undefined;
  TagKeys: string[] | undefined;
}
